Once you've created a new repository, please complete the following checklist:

- [ ] Complete the README (see instructions at the top of the file).
- [ ] If needed for this repository’s technology or framework, add rules or overrides (to the marked section if present) to the following configuration files:
  - [ ] `.editorconfig`
  - [ ] `.prettierrc` (only add to the `overrides` array)
  - [ ] `.prettierignore`
  - [ ] `.gitignore`
  - [ ] `.vscode/*.json`
  - [ ] `.github/CODEOWNERS`
- [ ] Add a linting configuration to this repository. E.g. if JavaScript-based, add [ESLint](https://eslint.org/docs/latest/use/getting-started). _Ideally, a lint task should run automatically on every commit to avoid being human linters in pull requests (see [lint-staged](https://github.com/okonet/lint-staged))._
- [ ] Add the relevant package configuration file. E.g. if an npm package, add a [package.json](https://docs.npmjs.com/cli/v9/configuring-npm/package-json) file.
- [ ] Add the relevant publishing pipeline and document it in the README (see instructions there). E.g. a [GitHub Action](https://github.com/features/actions) pipeline.
- [ ] Refrain from adding [community health files](https://docs.github.com/en/communities/setting-up-your-project-for-healthy-contributions/creating-a-default-community-health-file) to the `.github` folder (see the contributing guidelines [here](https://github.com/kinde-oss/.github/blob/02d19d8d2225444a29d2d2046a2726f7b17155fb/.github/CONTRIBUTING.md#community-health-files)).
- [ ] Once the checklist is complete, delete this file.
